/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * near * terra * litecoin * bitcoincash * solana  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet * litecoin/testnet * bitcoincash/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc) * terra/mainnet - [Terra RPC Documentation](https://docs.terra.money/docs/develop/how-to/endpoints.html) * litecoin/mainnet - [Litecoin RPC Documentation](https://litecoin.info/index.php/Litecoin_API) * bitcoincash/mainnet - [Bitcoin Cash RPC Documentation](https://docs.bitcoincashnode.org/doc/json-rpc/) * solana/mainnet - [Solana RPC Documentation](https://docs.solana.com/developing/clients/jsonrpc-api)  A full URL example: https://ubiquity.api.blockdaemon.com/bitcoin/mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.gitlab.blockdaemon.ubiquity.invoker.JSON;


/**
 * Coin
 */
@JsonPropertyOrder({
  Coin.JSON_PROPERTY_HANDLE,
  Coin.JSON_PROPERTY_SLIP44,
  Coin.JSON_PROPERTY_SYMBOL,
  Coin.JSON_PROPERTY_NAME,
  Coin.JSON_PROPERTY_BLOCK_TIME,
  Coin.JSON_PROPERTY_SAMPLE_ADDRESS
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class Coin {
  public static final String JSON_PROPERTY_HANDLE = "handle";
  private String handle;

  public static final String JSON_PROPERTY_SLIP44 = "slip44";
  private Integer slip44;

  public static final String JSON_PROPERTY_SYMBOL = "symbol";
  private String symbol;

  public static final String JSON_PROPERTY_NAME = "name";
  private String name;

  public static final String JSON_PROPERTY_BLOCK_TIME = "block_time";
  private Integer blockTime;

  public static final String JSON_PROPERTY_SAMPLE_ADDRESS = "sample_address";
  private String sampleAddress;


  public Coin handle(String handle) {
    this.handle = handle;
    return this;
  }

   /**
   * Platform handle (platform var in path)
   * @return handle
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "ethereum", value = "Platform handle (platform var in path)")
  @JsonProperty(JSON_PROPERTY_HANDLE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getHandle() {
    return handle;
  }


  @JsonProperty(JSON_PROPERTY_HANDLE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setHandle(String handle) {
    this.handle = handle;
  }


  public Coin slip44(Integer slip44) {
    this.slip44 = slip44;
    return this;
  }

   /**
   * SatoshiLabs 0044, registered coin types: https://github.com/satoshilabs/slips/blob/master/slip-0044.md
   * @return slip44
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "60", value = "SatoshiLabs 0044, registered coin types: https://github.com/satoshilabs/slips/blob/master/slip-0044.md")
  @JsonProperty(JSON_PROPERTY_SLIP44)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getSlip44() {
    return slip44;
  }


  @JsonProperty(JSON_PROPERTY_SLIP44)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSlip44(Integer slip44) {
    this.slip44 = slip44;
  }


  public Coin symbol(String symbol) {
    this.symbol = symbol;
    return this;
  }

   /**
   * Symbol of native currency
   * @return symbol
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "ETH", value = "Symbol of native currency")
  @JsonProperty(JSON_PROPERTY_SYMBOL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSymbol() {
    return symbol;
  }


  @JsonProperty(JSON_PROPERTY_SYMBOL)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSymbol(String symbol) {
    this.symbol = symbol;
  }


  public Coin name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Name of platform
   * @return name
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "Ethereum", value = "Name of platform")
  @JsonProperty(JSON_PROPERTY_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getName() {
    return name;
  }


  @JsonProperty(JSON_PROPERTY_NAME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setName(String name) {
    this.name = name;
  }


  public Coin blockTime(Integer blockTime) {
    this.blockTime = blockTime;
    return this;
  }

   /**
   * Average time between blocks (milliseconds)
   * @return blockTime
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "60000", value = "Average time between blocks (milliseconds)")
  @JsonProperty(JSON_PROPERTY_BLOCK_TIME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public Integer getBlockTime() {
    return blockTime;
  }


  @JsonProperty(JSON_PROPERTY_BLOCK_TIME)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setBlockTime(Integer blockTime) {
    this.blockTime = blockTime;
  }


  public Coin sampleAddress(String sampleAddress) {
    this.sampleAddress = sampleAddress;
    return this;
  }

   /**
   * Random address seen on chain (optional)
   * @return sampleAddress
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "Random address seen on chain (optional)")
  @JsonProperty(JSON_PROPERTY_SAMPLE_ADDRESS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSampleAddress() {
    return sampleAddress;
  }


  @JsonProperty(JSON_PROPERTY_SAMPLE_ADDRESS)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSampleAddress(String sampleAddress) {
    this.sampleAddress = sampleAddress;
  }


  /**
   * Return true if this coin object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    Coin coin = (Coin) o;
    return Objects.equals(this.handle, coin.handle) &&
        Objects.equals(this.slip44, coin.slip44) &&
        Objects.equals(this.symbol, coin.symbol) &&
        Objects.equals(this.name, coin.name) &&
        Objects.equals(this.blockTime, coin.blockTime) &&
        Objects.equals(this.sampleAddress, coin.sampleAddress);
  }

  @Override
  public int hashCode() {
    return Objects.hash(handle, slip44, symbol, name, blockTime, sampleAddress);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class Coin {\n");
    sb.append("    handle: ").append(toIndentedString(handle)).append("\n");
    sb.append("    slip44: ").append(toIndentedString(slip44)).append("\n");
    sb.append("    symbol: ").append(toIndentedString(symbol)).append("\n");
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    blockTime: ").append(toIndentedString(blockTime)).append("\n");
    sb.append("    sampleAddress: ").append(toIndentedString(sampleAddress)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

